function maxPath = ComputeViterbiPath(obj, Input, Label)
 
[C,S,N] = size(obj.WI_local);

D = size(obj.WI_obs, 2);
 
% Stores the previous best state, to backtrack. First col unused.
PrevState = zeros(C, N);
PrevValues = zeros(C, 1);
 
% Initialize values for i=1.
for c=1:C
  PrevValues(c) = obj.W(obj.WI_local(c,Label,1)) + ...
                  obj.W(obj.WI_obs(c,:)) * (Input(1) .^ [0:D-1]');
end
 
for i=2:N
  CurrentValues = zeros(C, 1);
  for c=1:C
    %[maxValue, maxIndex] = max(PrevValues + (obj.W(obj.WI_pairwise(:,c,Label))' ./ N));
    [maxValue, maxIndex] = max(PrevValues + (obj.W(obj.WI_pairwise(:,c,Label))'));
    
    PrevState(c, i) = maxIndex;
    
    CurrentValues(c) = maxValue + ...
        obj.W(obj.WI_local(c,Label,i)) + ...
        obj.W(obj.WI_obs(c,:)) * (Input(i) .^ [0:D-1]');
 
  end
 
  PrevValues = CurrentValues;
end
 
% Build path, tracking backwards.
maxPath = zeros(1, N);
[dummy, maxPath(N)] = max(PrevValues);
for i=N:-1:2
  maxPath(i-1) = PrevState(maxPath(i), i);
end
return
