function obj = HHCRF(N, NumStates, NumLabels, NumObsFeatures, InitMeans, InitStdevs, InitPairwise)
% constructor.
if (nargin == 1) && isa(N, 'HHCRF')
  obj = N;
else
  if nargin < 1, N = 0; end
  obj.SeqLength = N;

  if nargin < 2, NumStates = 2; end
  obj.NumStates = NumStates;

  if nargin < 3, NumLabels = 2; end
  obj.NumLabels = NumLabels;
  
  if nargin < 4, NumObsFeatures = 3; end
  obj.NumObsFeatures = NumObsFeatures;
  
  if nargin < 5, InitMeans = ((1:NumStates)' - 2) .* 0.25; end
  obj.InitMeans = InitMeans;
  
  if nargin < 6, InitStdevs = ones(NumStates, 1) .* 0.3; end
  obj.InitStdevs = InitStdevs;
  
  if nargin < 6, InitStdevs = ones(NumStates, 1) .* 0.3; end
  obj.InitPairwise = InitPairwise;

  obj.WI_pairwise = [];
  obj.WI_local = [];
  obj.WI_obs = [];
  obj.WI_regularized = [];
  obj.WI_constant = [];
  obj.W = [];
  
  obj = class(obj, 'HHCRF');

  obj = initialize(obj);
end