function logAlpha = ComputeAlpha(MP, Inputs)

[C,S,N] = size(MP.WI_local);
D = size(MP.WI_obs, 2);
assert(D == 3); % for now. assumed below for F_obs.
T = size(Inputs, 1);

%expW_pairwise = exp(MP.W(MP.WI_pairwise)); % CxCxS
%expW_local = exp(MP.W(MP.WI_local)); % CxSxN
W_obs = MP.W(MP.WI_obs); % CxD

logAlpha = zeros(C,S,N,T);
logAlpha(:,:,1,:) = 0; % log(1 ./ C ./ S);

%Scaling = zeros(1,1,N,T);
%Scaling(1,1,1,:) = sum(sum(Alpha(:,:,1,:), 1));

Fi_obs = ones(T,D); % TxD
for i=2:N
  % Update obs features. Assumes D=3 (1,x,x^2).
  Fi_obs(:,2) = Inputs(:,i-1);
  Fi_obs(:,3) = Fi_obs(:,2) .* Fi_obs(:,2);
  
  %expW_obs_times_Xi = exp(W_obs * Fi_obs'); % CxT = CxD * DxT
  logAlpha(:,:,i,:) = ... % CxSx1xT
      logsum(... % CxSxC*xT
        bsxfun(@plus, ...
          bsxfun(@plus, permute(MP.W(MP.WI_local(:,:,i-1)), [3 2 1 4]), ... % CxSxN Cx1x1 C*xSx1
                        permute(MP.W(MP.WI_pairwise), [2 3 1 4])), ... % CxCxS Cx1x1 C*xCxS
          bsxfun(@plus, permute(logAlpha(:,:,i-1,:), [3 2 1 4]), ... 1xSxC*xT
                        permute(W_obs * Fi_obs', [3 4 1 2])) ... % CxT 1x1 C*xT
        ), 3);
  %Scaling(1,1,i,:) = sum(sum(Alpha(:,:,i,:), 1), 2);
  % %Scaling(1,:,i,:) = 1;
  %Alpha(:,:,i,:) = bsxfun(@rdivide, Alpha(:,:,i,:), Scaling(1,1,i,:));

%   for t=1:T
%     expW_obs_times_x = expW_obs_times_X(:,t); % Cx1 = CxD * Dx1
%     for s=1:S
%       for c=1:C
%         %acc = 0;
%         %for cj=1:C
%           %acc = acc + Alpha(cj,s,i-1,t) * ...
%           %    expW_pairwise(cj,c,s) * ...
%           %    expW_local(cj,s,i-1) * ...
%           %    expW_obs_times_x(cj);
%         %end
%         %Alpha(c,s,i,t) = acc;
%         Alpha(c,s,i,t) = sum(Alpha(:,s,i-1,t) .* ... % CxSxNxT Cx1x1x1
%               expW_pairwise(:,c,s) .* ... % CxCxS Cx1x1
%               expW_local(:,s,i-1) .* ... % CxSxN Cx1x1
%               expW_obs_times_x);
%       end
%     end
%   end

%  Alpha(:,:,i,:) = sum( ...
%      repmat(permute(Alpha(:,:,i,:), [5,2,3,4,1]), [1,1,1,1,C]) .* exp(
%      repmat(permute(MP.W_pairwise_shared(:,:,:), [2,3,4,5,]), [ ]) + ...
%      repmat(permute(MP.W_pairwise_shared(:,:,i-1), [ ]), [ ]) + ...
%      repmat(permute(MP.W_pairwise_shared(:,:,i-1), [ ]), [ ]) ),
%      5);
end

return
