function E = ComputeEmpiricalExpectations(MP, Inputs, Labels, logP_pairwise, logP_position, logP_posterior)
[C,S,N] = size(MP.WI_local);
D = size(MP.WI_obs, 2);
T = size(Inputs, 1);
E = zeros(size(MP.W));
 
% Pairwise features.
for c=1:C
  for cj=1:C
    for s=1:S
      logP = logsum(logP_pairwise(c,cj,s,:,:), 4);
      logZ = permute(logP_posterior(s, :), [1,3,4,5,2]);
      %P(Z == 0) = 0;
      %Z(Z == 0) = 1;
      E(MP.WI_pairwise(c,cj,s)) = mean( ...
            permute(Labels == s, [2,3,4,5,1]) .* ...
            exp(logP - logZ), 5);
%       E(MP.WI_pairwise(c,cj,s)) = mean( ...
%             permute(Labels == s, [2,3,4,5,1]) .* ...
%             sum(P_pairwise(c,cj,s,:,:), 4) ./ ...
%             permute(P_posterior(s, :), [1,3,4,5,2]), 5);
    end
  end
end
 
% Local features.
for c=1:C
  for s=1:S
    for i=1:N
      logP = logP_position(c,s,i,:);
      logZ = permute(logP_posterior(s, :), [1,3,4,2]);
      %P(Z == 0) = 0;
      %Z(Z == 0) = 1;
      E(MP.WI_local(c,s,i)) = mean( ...
              permute(Labels == s, [2,3,4,1]) .* ...
              exp(logP - logZ), 4);
%       E(MP.WI_local(c,s,i)) = mean( ...
%               permute(Labels == s, [2,3,4,1]) .* ...
%               P_position(c,s,i,:) ./ ...
%               permute(P_posterior(s, :), [1,3,4,2]), 4);
    end
  end
end
 
% Observation features.
E_s = zeros(S,1);
for c=1:C
  for d=1:D
    for s=1:S
      P = sum(exp(logP_position(c,s,:,:)) .* permute(Inputs(:,:), [3,4,2,1]).^(d-1), 3);
      Z = exp(permute(logP_posterior(s, :), [1,3,4,2]));
      P(Z == 0) = 0;
      Z(Z == 0) = 1;
      E_s(s) = mean( ...
              permute(Labels == s, [2,3,4,1]) .* ...
              P ./ Z, 4);
%       E_s(s) = mean( ...
%               permute(Labels == s, [2,3,4,1]) .* ...
%               sum(P_position(c,s,:,:) .* permute(Inputs(:,:), [3,4,2,1]).^(d-1), 3) ./ ...
%               permute(P_posterior(s, :), [1,3,4,2]), 4);
    end
    E(MP.WI_obs(c,d)) = sum(E_s);
  end
end
 
return
