function E = ComputeModelExpectations(MP, Inputs, logP_pairwise, logP_position)
[C,S,N] = size(MP.WI_local);
D = size(MP.WI_obs, 2);
T = size(Inputs, 1);
E = zeros(size(MP.W));
 
% Pairwise features.
for c=1:C
  for cj=1:C
    for s=1:S
      E(MP.WI_pairwise(c,cj,s)) = exp(logsum(logsum(logP_pairwise(c,cj,s,:,:), 4), 5)) ./ T;
    end
  end
end
 
% Local features.
for c=1:C
  for s=1:S
    E(MP.WI_local(c,s,:)) = exp(logsum(logP_position(c,s,:,:), 4)) ./ T;
  end
end
 
% Observation features.
E_s = zeros(S,1);
for c=1:C
  for d=1:D
    for s=1:S
      E_s(s) = mean(sum(exp(logP_position(c,s,:,:)) .* permute(Inputs(:,:), [3,4,2,1]).^(d-1), 3), 4);
    end
    E(MP.WI_obs(c,d)) = sum(E_s);
  end
end
 
return
