function logP = ComputePairwiseMarginals(MP, Inputs, logAlpha, logBeta)
% Computes P_model(c_{i},c_{i+1}, s | x) of dimension CxCxSx(N-1)xT

[C,S,N,T] = size(logAlpha);
D = size(MP.WI_obs, 2);
%P = zeros(C,C,S,N-1,T);

%expW_pairwise = exp(MP.W(MP.WI_pairwise)); % CxCxS
%expW_local = exp(MP.W(MP.WI_local)); % CxSxN

W_obs_times_X = sum(bsxfun(@times, ...
    permute(MP.W(MP.WI_obs), [1 3 4 2]), ... % Cx1x1xD
    permute(bsxfun(@power, Inputs, permute(0:D-1, [1 3 2]) ... % TxNxDt
                  ), [4 2 1 3]) ... % 1xNxTxD 
  ), 4); % CxNxT

logP = bsxfun(@plus, ...
  bsxfun(@plus, ...
    bsxfun(@plus, ...
      permute(logAlpha(:,:,1:N-1,:), [1 5 2 3 4]), ... % Cx1xSxN-1xT
      permute(W_obs_times_X(:,1:N-1,:), [1 4 5 2 3]) ... % Cx1x1xN-1xT
    ), ...
    bsxfun(@plus, ...
        permute(logBeta(:,:,2:N,:), [5 1 2 3 4]), ... % 1xCxSxN-1xT
      permute(W_obs_times_X(:,2:N,:), [4 1 5 2 3]))), ... % 1xCx1xN-1xT
  bsxfun(@plus, ...
    bsxfun(@plus, ...
      permute(MP.W(MP.WI_pairwise), [1 2 3 4 5]), ... % CxCxSx1x1
      permute(MP.W(MP.WI_local(:,:,1:N-1)), [1 4 2 3 5])), ... % Cx1xSxNx1
      permute(MP.W(MP.WI_local(:,:,2:N)), [4 1 2 3 5]))); % 1xCxSxNx1
% Normalize.
logZ = logsum(logsum(logsum(logP, 1), 2), 3);
logP = bsxfun(@minus, logP, logZ);

% for i=1:N-1
%   for t=1:T
%     for s=1:S
%       for c=1:C
%         for cj=1:C
%           P(c,cj,s,i,t) = Alpha(c,s,i,t) * Beta(cj,s,i+1,t) * exp( ...
%               MP.W(MP.WI_pairwise(c,cj,s)) + ...
%               MP.W(MP.WI_local(c,s,i)) + ...
%               MP.W(MP.WI_local(cj,s,i+1)) + ...
%               MP.W(MP.WI_obs(c,:)) * (Inputs(t,i) .^ [0:D-1]') + ...
%               MP.W(MP.WI_obs(cj,:)) * (Inputs(t,i+1) .^ [0:D-1]') ...
%           );
% %              MP.W(MP.WI_obs(c,1)) + MP.W(MP.WI_obs(c,2)) .* Inputs(t,i) + MP.W(MP.WI_obs(c,3)) .* Inputs(t,i) .* Inputs(t,i) + ...
% %              MP.W(MP.WI_obs(cj,1)) + MP.W(MP.WI_obs(cj,2)) .* Inputs(t,i+1) + MP.W(MP.WI_obs(cj,3)) .* Inputs(t,i+1) .* Inputs(t,i+1) ...
%         end
%       end
%     end
%     % Normalize.
%     P(:,:,:,i,t) = P(:,:,:,i,t) ./ sum(sum(sum(P(:,:,:,i,t), 1), 2), 3);
%   end
% end
return
 
