function logP = ComputePositionMarginals(MP, Inputs, logAlpha, logBeta)
% Computes P_model(c_{i}, s | x) of dimension CxSxNxT

[C,S,N,T] = size(logAlpha);
D = size(MP.WI_obs, 2);
%P = zeros(C,S,N,T);

%expW_local = exp(MP.W(MP.WI_local)); % CxSxN

W_obs_times_X = sum(bsxfun(@times, ...
    permute(MP.W(MP.WI_obs), [1 3 4 2]), ... % Cx1x1xD
    permute(bsxfun(@power, Inputs, permute(0:D-1, [1 3 2]) ... % TxNxD
                  ), [4 2 1 3]) ... % 1xNxTxD 
  ), 4); % CxNxT

logP = bsxfun(@plus, ...
      bsxfun(@plus, ...
        bsxfun(@plus, ...
          logAlpha, ... % CxSxNxT
          logBeta), ... % CxSxNxT
          permute(W_obs_times_X, [1 4 2 3])), ... % Cx1xNxT
          MP.W(MP.WI_local)); % CxSxNx1
% Normalize.
logZ = logsum(logsum(logP, 1), 2);
%Z(Z == 0) = 1;
logP = bsxfun(@minus, logP, logZ);

% 
% for i=1:N
%   for t=1:T
%     for c=1:C
%         for s=1:S
%           P(c,s,i,t) = Alpha(c,s,i,t) * Beta(c,s,i,t) * exp( ...
%               obj.W(obj.WI_local(c,s,i)) + ...
%               obj.W(obj.WI_obs(c,:)) * (Inputs(t,i) .^ [0:D-1]') ...
%           );
%         end
%     end
%     % Normalize.
%     P(:,:,i,t) = P(:,:,i,t) ./ sum(sum(P(:,:,i,t), 1), 2);
%   end
% end
return
