function [means, stdevs] = fitKMeans(Inputs, K, maxIters)

if nargin < 3,
  maxIters = 100;
end

%vmax = max(max(Inputs));
%vmin = min(min(Inputs));
vmean = mean(mean(Inputs));
vstd = std(Inputs(:));

%means = vmin + ((vmax - vmin)./(K-1)).*[0:(K-1)]';
means = sort(randn(K,1) .* vstd + vmean);

I_min_prev = [];
for iter = 1:maxIters
  dist = abs(bsxfun(@minus, permute(Inputs, [3 1 2]), means));
  [dist_min, I_min] = min(dist, [], 1);
  
  if isequal(I_min_prev, I_min)
    disp(sprintf('K-means stopping with no change after iteration %d.', iter));
    break;
  end
  
  for i=1:K
    means(i) = mean(Inputs(permute(I_min, [2 3 1]) == i));
  end
  I_min_prev = I_min;
end
if iter == maxIters
  disp(sprintf('K-means completed %d iterations.', maxIters));
end

if nargout > 1
  stdevs = zeros(K,1);
  for i=1:K
    stdevs(i) = std(Inputs(permute(I_min, [2 3 1]) == i));
  end
end
