function obj = initialize(obj)
C = obj.NumStates;
S = obj.NumLabels;
N = obj.SeqLength;

% Create model weights.
obj.WI_pairwise = zeros(C, C, S);
obj.WI_local = zeros(C, S, N);
obj.WI_obs = zeros(C, obj.NumObsFeatures);
NumWeights = numel(obj.WI_pairwise) ...
           + numel(obj.WI_local) ...
           + numel(obj.WI_obs);
obj.W = zeros(1, NumWeights);

% Set up weight indices.
count1 = numel(obj.WI_pairwise);
obj.WI_pairwise(:) = 1:count1;
count2 = numel(obj.WI_local);
obj.WI_local(:) = count1+(1:count2);
obj.WI_obs(:) = count1+count2+(1:numel(obj.WI_obs));
assert(count1+count2+numel(obj.WI_obs) == NumWeights);

% Parameters to be constrained to constant.
obj.WI_constant = [];
% The diagonal of the pairwise (transition) parameters.
%for i=1:C
%  temp = obj.WI_pairwise(i,i,:);
%  obj.WI_constant = [obj.WI_constant, temp(:)'];
%end
% The off-diagonal of the pairwise (transition) parameters.
for i=1:C
  temp = [obj.WI_pairwise(i,1:i-1,:) obj.WI_pairwise(i,i+1:end,:)];
  obj.WI_constant = [obj.WI_constant, temp(:)'];
end

% All local parameters for S=1.
%temp = obj.WI_local(:,1,:);
%obj.WI_constant = [obj.WI_constant, temp(:)'];
% All local parameters for S=1,C=1.
%temp = obj.WI_local(1,1,:);
%obj.WI_constant = [obj.WI_constant, temp(:)'];
% All local parameters for S=2,C=1.
%temp = obj.WI_local(1,2,:);
%obj.WI_constant = [obj.WI_constant, temp(:)'];

% Parameters to be regularized.Y
obj.WI_regularized = [];
obj.WI_regularized = setdiff(obj.WI_local(:)', obj.WI_constant);

% Initialize params intelligently.
% TODO: Use clustering for this.
%%mu = ((1:C)' - 1) .* 0.25;
%mu = ((1:C)' - 2) .* 0.25;
mu = obj.InitMeans;
sigma = obj.InitStdevs;

%%sigma = ones(C, 1) .* 0.3;
%sigma = ones(C, 1) .* 0.3;
obj.W(obj.WI_obs) = -0.5 .* [mu.^2, -2.*mu, ones(C,1)] ./ repmat(sigma.^2, 1,3);
%%obj.W(obj.WI_obs) = [0.0765 -1.0998 -5.9435 ; -1.7570 7.2109 -5.1676];

% % % obj.W(obj.WI_pairwise) = - (repmat(eye(C), [1,1,S]) + 0.01 .* randn(C,C,S));
% % %obj.W(obj.WI_local(2,2,:)) = ones([1,1,N]) .* 0.01;
obj.W(obj.WI_pairwise) = (repmat(eye(C), [1,1,S])) * obj.InitPairwise;
% obj.W(obj.WI_pairwise) = (repmat(eye(C), [1,1,S])) * 0.01;
% %obj.W(obj.WI_pairwise(:,:,1)) = [1.1307, 0 ; 0, 0.8618];
% %obj.W(objC=2;.WI_pairwise(:,:,2)) = [1.0685, 0 ; 0, 0.9714];
